﻿
Imports System
Imports System.ComponentModel
Imports System.Threading


Public Class frmMain
    Dim icBox As New IcBoxClassLibrary.IcBox  'instancia icbox
    Dim myPort As Array
    Private trd As Thread
    Delegate Sub SetProgressCallback(ByVal valor As Integer)
    Delegate Sub SetTextCallback(ByVal valor As String)

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        listPorts()

        btDesconectar.Enabled = False
        icBox.initialize("")
        setEnableGroups(False)

        trd = New Thread(AddressOf ThreadTask)
        trd.IsBackground = True
        trd.Start()

    End Sub
    Private Sub listPorts()
        myPort = icBox.GetPorts
        For i = 0 To UBound(myPort)
            cbxComPort.Items.Add(myPort(i))
        Next
        cbxComPort.Text = cbxComPort.Items.Item(0)
    End Sub

    'Abre a porta serial
    'Internamente os valores de configuração são 57600  8N1
    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btConectar.Click
        Dim portName As String = cbxComPort.Text


        If icBox.openCom(portName) Then
            btConectar.Enabled = False
            btDesconectar.Enabled = True
            setEnableGroups(True)
        Else
            'erro
        End If



    End Sub
    'Atualiza lista de portas COM no combo
    Private Sub btAtualizar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btAtualizar.Click
        cbxComPort.Items.Clear()
        listPorts()
    End Sub
    'habilita e desabilita os componentes de tela de acordo com o estado da conexão
    Private Sub setEnableGroups(ByVal arg As Boolean)
        GroupBox1.Enabled = arg
        GroupBox3.Enabled = arg
        GroupBox4.Enabled = arg
        GroupBox5.Enabled = arg
        GroupBox6.Enabled = arg
        GroupBox7.Enabled = arg
        GroupBox8.Enabled = arg
        GroupBox9.Enabled = arg

    End Sub
    'Desconecta a porta Serial
    Private Sub btnDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btDesconectar.Click

        If icBox.closeCom() Then
            btConectar.Enabled = True
            btDesconectar.Enabled = False
            setEnableGroups(False)
        Else
            'Erro
        End If

    End Sub
    'Retorna a versão do firmware do Icbox

    Private Sub btnSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btVersionInfo.Click

        If icBox.isConnected Then
            lbVersionInfo.Text = icBox.getVersionInfo()
        End If

    End Sub
    'Informa se o IcBox detecta se o telefone está no gancho ou fora do gancho
    'Caso a linha telefônica esteja desconectada, o Icbox indicará "fora do gancho"
    Private Sub btGancho_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGancho.Click
        If icBox.isConnected Then
            If icBox.getOnHook() Then
                lbGancho.Text = "No Gancho"
            Else
                lbGancho.Text = "Fora do Gancho"

            End If
        End If
    End Sub

    'Retorna o estado de conexao da porta serial
    'Confia unicamente no componente Serial
    'menos confiável porém, mais rápido
    Private Sub btConnected_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btConnected.Click
        If icBox.isConnected() Then
            lbConectado.Text = "Conectado"
        Else
            lbConectado.Text = "Desconectado"
        End If
    End Sub

    'Informa se o Icbox está conectado e se comunicando corretamente com o computador
    'É enviado um comando e testado o se o retorno é o esperado
    '
    Private Sub btConnectionStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btConnectionStatus.Click
        If icBox.isConnected Then
            If icBox.checkConnectionStatus() Then
                lbConnectionStatus.Text = "Conectado"
            Else
                lbConnectionStatus.Text = "Desconectado"
            End If
        End If

    End Sub

    'Recupera o nível de Recepção gravado no icbox
    Private Sub btGetRxLevel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGetRxLevel.Click
        If icBox.isConnected Then
            lbRXLevel.Text = Str(icBox.getRXLevel())
        End If
    End Sub

    'Configura o nível de sensiblidade  na identificação de chamadas. Valores de 1 a 8. 
    'Quando o número identificado faltam ou repetem números erroneamente, o ajuste neste nível pode ajudar a corrigir 
    ' 1 - Menos sensível, maior atenuação
    ' 8 - Mais sensível, menor atenuação
    'Valor default - 4.  A informação é gravada na memória Flash

    Private Sub btSetRXLevel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSetRXLevel.Click

        Dim strRXLevel As String
        Dim intRXLevel As Integer


        strRXLevel = edtRXLevel.Text.Trim
        Try
            intRXLevel = Val(strRXLevel)
            If intRXLevel > 0 AndAlso intRXLevel < 9 Then
                If icBox.setRXLevel(intRXLevel) Then
                    ' sucesso
                    lbRXLevel.Text = strRXLevel
                End If
            End If
        Catch ex As Exception

        End Try


    End Sub

    'Retorna o modo de identificação de chamadas 1- Automático DTMF/FSK 2 - DTMF 3- FSK
    Private Sub btGetRXMode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGetRXMode.Click
        If icBox.isConnected Then
            lbRXMode.Text = Str(icBox.getRXMode())
        End If
    End Sub

    'Configura o modo de identificação de chamadas 1- Automático DTMF/FSK 2 - DTMF 3- FSK
    'Quando a detecção automática falhar, o modo DTMF ou FSK deve ser usado.
    'O valor default é 1. Retorna o sucesso da gravação da configuração
    Private Sub btSetRXMode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSetRXMode.Click
        Dim strRXMode As String
        Dim intRXMode As Integer


        strRXMode = edtRXMode.Text.Trim
        Try
            intRXMode = Val(strRXMode)
            If intRXMode > 0 AndAlso intRXMode < 9 Then
                If icBox.setRXMode(intRXMode) Then
                    ' sucesso
                    lbRXMode.Text = strRXMode
                End If
            End If
        Catch ex As Exception

        End Try


    End Sub

    'Retorno  Id do IcBox. Este Id é util para se identificar unicamente quando se tem mais de um Icbox conectado no mesmo computador
    'e é composto por 3 caracteres numéricos. 
    Private Sub btGetId_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btGetId.Click
        If icBox.isConnected Then
            lbId.Text = icBox.getId()
        End If
    End Sub

    'Configura o Id para o IcBox. Este Id é util para se identificar unicamente quando se tem mais de um Icbox conectado no mesmo computador
    'é composto por 3 caracteres numéricos. Retorno um booleano com o sucesso da gravação
    'O Id é gravado na memória Flash interna do IcBox. O valor de fábrica é 001
    Private Sub btSetId_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSetId.Click
        Dim strId As String

        strId = edtId.Text.Trim

        If strId.Length > 3 Then
            MsgBox("Id inválido", MsgBoxStyle.Exclamation, "Erro")
            Return

        Else
            For i As Integer = 1 To (3 - strId.Length)
                strId = "0" & strId
            Next

        End If


        Try
            If icBox.isConnected Then
                If icBox.setId(strId) Then
                    lbId.Text = strId
                End If
            End If

        Catch ex As Exception

        End Try

    End Sub

    'Envia um número para o IcBox gerar o DTMF
    'suporta até 22 dígitos. Para um intervalo de 500mSecs, adicione a letra P na sequencia de dígitos para discar
    'o retorno "True" indica que o comando foi recebido pelo icBox e não o fim da discagem
    Private Sub btDiscar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btDiscar.Click
        Dim strNumero As String

        strNumero = edtNumero.Text.Trim

        If 1 > strNumero.Length > 22 Then
            MsgBox("Número para discar inválido", MsgBoxStyle.Exclamation, "Erro")
        End If
        If icBox.isConnected Then
            If icBox.dialNumber(strNumero) Then
                MsgBox("Comando discar enviado com sucesso", MsgBoxStyle.Information, "Info")
            End If
        End If
    End Sub

    'Thread para pooling de captura de eventos
    'O progressBass é atualizado para indicar que o pooling está em execução
    'A cada apox 1000mSecs busca por eventos no buffer da serial
    Private Sub ThreadTask()
        Dim stp As Integer
        Dim evento As String
        stp = 0

        Do
            If Not chkProgramacao.Checked AndAlso icBox.isConnected Then
                stp += 10
                Me.SetProgress(stp)

                If stp = 100 Then
                    evento = icBox.getEvent(500)
                    If evento.Length > 0 Then
                        Me.SetText(evento)
                    End If
                    stp = 0
                End If

            End If

            evento = ""

            Thread.Sleep(100)
        Loop
    End Sub

    'Atua de acordo com o estado do check box. Se selecionado, a Thread não faz pooling para capturar eventos
    'Isto é necessário pois o pooling poderia interceptar a resposta de um comando de configuração
    Private Sub chkProgramacao_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkProgramacao.CheckedChanged
        If chkProgramacao.Checked Then
            ProgressBar1.Enabled = False
            ProgressBar1.Value = 0
        Else

            ProgressBar1.Enabled = True
        End If


    End Sub

    'Atualiza o progress bas
    Private Sub SetProgress(ByVal valor As Integer)

        If Me.ProgressBar1.InvokeRequired Then
            Dim d As New SetProgressCallback(AddressOf SetProgress)
            Me.Invoke(d, New Object() {valor})
        Else
            Me.ProgressBar1.Value = valor
        End If
    End Sub

    'Envia novo evento para o TextEdit
    Private Sub SetText(ByVal valor As String)

        If Me.txtBox.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf SetText)
            Me.Invoke(d, New Object() {valor})
        Else
            Me.txtBox.Text += valor + vbCrLf
        End If
    End Sub


End Class
